﻿Imports System.IO
Imports System.Text
Imports rssgs_generating_iq_modulated_signal_example.InstrumentDriversVB

Public Class rssgs_generating_iq_modulated_signal_example

    Private m_instrument As rssgs

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub EnableButtons(ByVal enable As Boolean)           
        SettingsGB.Enabled = enable
        IQSettingsGB.Enabled = enable

        If m_instrument Is Nothing Then
            enable = False
        Else
            enable = True
        End If

        ResourceGB.Enabled = Not (enable)
        ConnectBtn.Enabled = Not (enable)
        ApplyBtn.Enabled = enable
        GainImbaDispl.Enabled = False
    End Sub

    Private Sub ConnectBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectBtn.Click
        Try
            ''lock GUI
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor
            EnableButtons(False)

            'initialize driver
            If m_instrument Is Nothing Then
                m_instrument = New rssgs(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_instrument.reset()
            End If

        Catch ex As Exception
            Dim message As String

            message = "Instrument Status Error: "
            message += ex.Message
            MessageBox.Show(message)

        Finally
            UseWaitCursor = False
            System.Windows.Forms.Cursor.Current = Cursors.Default
            EnableButtons(True)
        End Try
    End Sub

    Private Sub ExitBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitBtn.Click
        Close()
    End Sub

    Private Sub ApplyBtn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ApplyBtn.Click
        Dim gainImbaRead As Double

        Try
            EnableButtons(False)

            m_instrument.SetOperationMode(rssgsConstants.OperationModeNormal)

            m_instrument.SetFrequencyAndLevel(Convert.ToDouble(RFFreq.Value), Convert.ToDouble(Level.Value))

            m_instrument.SetROSCSource(rssgsConstants.SourceInt)

            m_instrument.SetFrequencyLocalOscillatorSource(rssgsConstants.SourceInt)

            m_instrument.SetIQImpairmentsIOffset(Convert.ToDouble(IOffset.Value))

            m_instrument.SetIQImpairmentsQOffset(Convert.ToDouble(QOffset.Value))

            m_instrument.SetIQImpairmentsGainImbalance(Convert.ToDouble(GainImba.Value))

            m_instrument.GetIQImpairmentsGainImbalance(gainImbaRead)
            GainImbaDispl.Text = Convert.ToString(gainImbaRead)

            m_instrument.SetIQImpairmentsQuadratureOffset(Convert.ToDouble(QuadOffset.Value))

            m_instrument.SetIQWideband(True)

            m_instrument.SetIQImpairmentsState(True)

            m_instrument.SetRFState(RFState.Checked)

        Catch ex As Exception
            Dim message As String

            message = "Instrument Status Error: "
            message += ex.Message
            MessageBox.Show(message)

        Finally
            UseWaitCursor = False
            System.Windows.Forms.Cursor.Current = Cursors.Default
            EnableButtons(True)
        End Try
    End Sub
End Class
